diff --git a/src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java
new file mode 100644
index 000000000..31a6a1ae3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.entity.projectile;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+
+// Referenced classes of package net.minecraft.src:
+//            Entity, AxisAlignedBB, Mob, MathHelper,
+//            World, Vec3D, MovingObjectPosition, NBTTagCompound, 
+//            Player, ItemStack, Item, InventoryPlayer
+
+public class SnowballProjectile extends Projectile
+{
+
+    public SnowballProjectile(World world)
+    {
+        super(world);
+        this.modelItem = Items.AMMO_SNOWBALL;
+    }
+
+    public SnowballProjectile(World world, Mob owner)
+    {
+        super(world, owner);
+        this.modelItem = Items.AMMO_SNOWBALL;
+    }
+
+    public SnowballProjectile(World world, double x, double y, double z)
+    {
+        super(world, x, y, z);
+        this.modelItem = Items.AMMO_SNOWBALL;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
similarity index 79%
rename from src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
rename to src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
index 74e99b3bd..c5639823a 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
@@ -1,17 +1,18 @@
 package net.minecraft.core.entity.vehicle;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.Packet26BoatControl;
+import net.minecraft.core.net.packet.BoatControlPacket;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.DamageType;
@@ -19,19 +20,43 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.List;
 
 // Referenced classes of package net.minecraft.src:
 //            Entity, World, Block, Item, 
-//            AxisAlignedBB, Material, MathHelper, EntityPlayer, 
+//            AxisAlignedBB, Material, MathHelper, Player,
 //            NBTTagCompound
 
-public class EntityBoat extends Entity
+public class BoatEntity extends Entity
 {
+    private static final double MAX_BOAT_SPEED = 0.8D;
+    private static final double ACCELERATION = 0.0065D;
+    private static final float MAX_ROTATION_SPEED = 5f;
+    private static final float MIN_ROTATION_SPEED = 3f;
+    private static final double MAX_PACKET_SPEED_CHANGE = ACCELERATION * 8;
+    private static final double MAX_PACKET_ROTATION_CHANGE = MAX_ROTATION_SPEED * 4;
+    public int boatCurrentDamage;
+    public int boatTimeSinceHit;
+    public int boatRockDirection;
+    private int lerpTicks;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private float lerpYRot;
+    private float boatPitch;
+    private double velocityX;
+    private double velocityY;
+    private double velocityZ;
+    private float pendingYRot;
+    private double pendingXDChange;
+    private double pendingZDChange;
+    private ItemStack flag = null;
+    public FlagBlockEntity tileEntityFlag = null;
+
 
-    public EntityBoat(World world)
+    public BoatEntity(World world)
     {
         super(world);
         boatCurrentDamage = 0;
@@ -46,7 +71,7 @@ public class EntityBoat extends Entity
     private void createTileEntity()
     {
         if (this.flag == null) return;
-        this.tileEntityFlag = new TileEntityFlag();
+        this.tileEntityFlag = new FlagBlockEntity();
         CompoundTag flagData = this.flag.getData().getCompoundOrDefault("FlagData", null);
         if (flagData != null)
         {
@@ -61,7 +86,7 @@ public class EntityBoat extends Entity
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
     }
 
@@ -77,7 +102,7 @@ public class EntityBoat extends Entity
         return true;
     }
 
-    public EntityBoat(World world, double d, double d1, double d2)
+    public BoatEntity(World world, double d, double d1, double d2)
     {
         this(world);
         setPos(d, d1 + (double) heightOffset, d2);
@@ -94,21 +119,20 @@ public class EntityBoat extends Entity
     {
         return (double) bbHeight * 0.0D - 0.3D;
     }
-
     @Override
     public boolean hurt(Entity entity, int i, DamageType type)
     {
         int numParticles = random.nextInt(8) + 1;
         for (int q = 0; q < numParticles; q++)
         {
-            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Block.planksOak.id, 0, Side.BOTTOM));
+            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id, 0, Side.BOTTOM));
         }
         if(world.isClientSide || removed)
         {
             return true;
         }
-        if(entity instanceof EntityPlayer) {
-        	if(((EntityPlayer) entity).getGamemode() == Gamemode.creative) {
+        if(entity instanceof Player) {
+        	if(((Player) entity).getGamemode() == Gamemode.creative) {
         		remove();
                 if (this.flag != null)
                 {
@@ -127,15 +151,15 @@ public class EntityBoat extends Entity
             {
                 passenger.startRiding(this);
             }
-            if(entity instanceof EntityPlayer){
-                spawnAtLocation(Item.boat.id, 1, 0.0F);
+            if(entity instanceof Player){
+                spawnAtLocation(Items.BOAT.id, 1, 0.0F);
             }else {
                 for (int j = 0; j < 3; j++) {
-                    spawnAtLocation(Block.planksOak.id, 1, 0.0F);
+                    spawnAtLocation(Blocks.PLANKS_OAK.id, 1, 0.0F);
                 }
 
                 for (int k = 0; k < 2; k++) {
-                    spawnAtLocation(Item.stick.id, 1, 0.0F);
+                    spawnAtLocation(Items.STICK.id, 1, 0.0F);
                 }
             }
             if (this.flag != null)
@@ -147,6 +171,7 @@ public class EntityBoat extends Entity
         }
         return true;
     }
+
     @Override
     public void remove(){
         Entity entity = passenger;
@@ -187,7 +212,7 @@ public class EntityBoat extends Entity
         boatPitch = xRot;
         lerpTicks = i;
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof EntityPlayerSP) return;
+        if (passenger instanceof LocalPlayer) return;
         lerpYRot = yRot;
         xd = velocityX;
         yd = velocityY;
@@ -198,12 +223,11 @@ public class EntityBoat extends Entity
 	public void lerpMotion(double xd, double yd, double zd)
     {
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof EntityPlayerSP) return;
+        if (passenger instanceof LocalPlayer) return;
         velocityX = this.xd = xd;
         velocityY = this.yd = yd;
         velocityZ = this.zd = zd;
     }
-
     @Override
 	public void tick()
     {
@@ -226,7 +250,7 @@ public class EntityBoat extends Entity
         {
             double minY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i)) / (double)waterSections) - 0.125D;
             double maxY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i + 1)) / (double)waterSections) - 0.125D;
-            AABB axisalignedbb = AABB.getBoundingBoxFromPool(bb.minX, minY, bb.minZ, bb.maxX, maxY, bb.maxZ);
+            AABB axisalignedbb = AABB.getTemporaryBB(bb.minX, minY, bb.minZ, bb.maxX, maxY, bb.maxZ);
             if(world.isAABBInMaterial(axisalignedbb, Material.water))
             {
                 bouyancy += 1.0D / (double)waterSections;
@@ -241,7 +265,7 @@ public class EntityBoat extends Entity
                 double lerpY = y + (this.lerpY - y) / (double) lerpTicks;
                 double lerpZ = z + (this.lerpZ - z) / (double) lerpTicks;
                 xRot += (boatPitch - xRot) / lerpTicks;
-                if (!(passenger instanceof EntityClientPlayerMP)){
+                if (!(passenger instanceof MultiplayerLocalPlayer)){
                     float lerpYRot;
                     lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - yRot);
                     yRot += lerpYRot / lerpTicks;
@@ -309,7 +333,7 @@ public class EntityBoat extends Entity
 
         }
 
-        if (!(passenger instanceof EntityPlayerMP)){
+        if (!(passenger instanceof ServerPlayer)){
             xd *= 0.99D;
             yd *= 0.95D;
             zd *= 0.99D;
@@ -318,11 +342,11 @@ public class EntityBoat extends Entity
         xRot = 0.0F;
 
         // Push entities in bounding box
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(0.2D, 0.0D, 0.2D));
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
         if(list != null && !list.isEmpty())
         {
             for (Entity entity : list) {
-                if (entity != passenger && entity.isPushable() && (entity instanceof EntityBoat)) {
+                if (entity != passenger && entity.isPushable() && (entity instanceof BoatEntity)) {
                     entity.push(this);
                 }
             }
@@ -332,9 +356,9 @@ public class EntityBoat extends Entity
         // Break snow layers on the ground
         for(int i = 0; i < 4; i++)
         {
-            int blockX = MathHelper.floor_double(x + ((double)(i % 2) - 0.5D) * 0.8D);
-            int blockY = MathHelper.floor_double(y);
-            int blockZ = MathHelper.floor_double(z + ((double)(i / 2) - 0.5D) * 0.8D);
+            int blockX = MathHelper.floor(x + ((double)(i % 2) - 0.5D) * 0.8D);
+            int blockY = MathHelper.floor(y);
+            int blockZ = MathHelper.floor(z + ((double)(i / 2) - 0.5D) * 0.8D);
             Block block = world.getBlock(blockX, blockY, blockZ);
             if(block != null && block.hasTag(BlockTags.BOAT_BREAKS))
             {
@@ -364,9 +388,9 @@ public class EntityBoat extends Entity
         double xdOff;
         double zdOff;
         currentBoatSpeed = Math.hypot(xd, zd);
-        if(passenger != null && passenger instanceof EntityPlayerSP)
+        if(passenger != null && passenger instanceof LocalPlayer)
         {
-            EntityPlayerSP sp = (EntityPlayerSP) passenger;
+            LocalPlayer sp = (LocalPlayer) passenger;
             controlBoat(-sp.input.moveForward, -sp.input.moveStrafe);
         }
         yRot += pendingYRot;
@@ -387,15 +411,15 @@ public class EntityBoat extends Entity
         xd += xdOff;
         zd += zdOff;
 
-        if (passenger instanceof EntityClientPlayerMP){
-            ((EntityClientPlayerMP)passenger).sendQueue.addToSendQueue(new Packet26BoatControl(this));
+        if (passenger instanceof MultiplayerLocalPlayer){
+            ((MultiplayerLocalPlayer)passenger).sendQueue.addToSendQueue(new BoatControlPacket(this));
         }
 
         // Cap max speed properly
         currentBoatSpeed = Math.hypot(xd, zd);
-        if (currentBoatSpeed > maxBoatSpeed){
-            xd = xd/currentBoatSpeed * maxBoatSpeed;
-            zd = zd/currentBoatSpeed * maxBoatSpeed;
+        if (currentBoatSpeed > MAX_BOAT_SPEED){
+            xd = xd/currentBoatSpeed * MAX_BOAT_SPEED;
+            zd = zd/currentBoatSpeed * MAX_BOAT_SPEED;
         }
 
         if(onGround)
@@ -405,18 +429,19 @@ public class EntityBoat extends Entity
             zd *= 0.5D;
         }
     }
+
     public void controlBoat(float forward, float strafe){
         double currentBoatSpeed = Math.hypot(xd, zd);
-        pendingYRot = (float) (strafe * (minRotSpeed + (maxRotSpeed - minRotSpeed) * Math.max(((maxBoatSpeed - (currentBoatSpeed * 1.5))/maxBoatSpeed), 0))); // I love interpolation
-        float velOff = (float) (forward * acceleration);
+        pendingYRot = (float) (strafe * (MIN_ROTATION_SPEED + (MAX_ROTATION_SPEED - MIN_ROTATION_SPEED) * Math.max(((MAX_BOAT_SPEED - (currentBoatSpeed * 1.5))/ MAX_BOAT_SPEED), 0))); // I love interpolation
+        float velOff = (float) (forward * ACCELERATION);
         pendingXDChange = Math.cos(Math.toRadians(yRot)) * velOff;
         pendingZDChange = Math.sin(Math.toRadians(yRot)) * velOff;
     }
 
     public void handleControlDirect(float xd, float zd, float yRot){
-        this.yRot = (float) MathHelper.clamp(yRot, this.yRot - maxSinglePacketRotationChange, this.yRot + maxSinglePacketRotationChange);
-        this.xd = MathHelper.clamp(xd, this.xd - maxSinglePacketSpeedChange, this.xd + maxSinglePacketSpeedChange);
-        this.zd = MathHelper.clamp(zd, this.zd - maxSinglePacketSpeedChange, this.zd + maxSinglePacketSpeedChange);
+        this.yRot = (float) MathHelper.clamp(yRot, this.yRot - MAX_PACKET_ROTATION_CHANGE, this.yRot + MAX_PACKET_ROTATION_CHANGE);
+        this.xd = MathHelper.clamp(xd, this.xd - MAX_PACKET_SPEED_CHANGE, this.xd + MAX_PACKET_SPEED_CHANGE);
+        this.zd = MathHelper.clamp(zd, this.zd - MAX_PACKET_SPEED_CHANGE, this.zd + MAX_PACKET_SPEED_CHANGE);
     }
 
     @Override
@@ -458,18 +483,18 @@ public class EntityBoat extends Entity
     }
 
     @Override
-	public boolean interact(EntityPlayer entityplayer)
+	public boolean interact(Player entityplayer)
     {
-        if(passenger != null && (passenger instanceof EntityPlayer) && passenger != entityplayer)
+        if(passenger != null && (passenger instanceof Player) && passenger != entityplayer)
         {
             return true;
         }
         if(!world.isClientSide)
         {
-            if (entityplayer.getHeldItem() != null && entityplayer.getHeldItem().itemID == Item.flag.id && flag == null)
+            if (entityplayer.getHeldItem() != null && entityplayer.getHeldItem().itemID == Items.FLAG.id && flag == null)
             {
                 this.flag = entityplayer.getHeldItem().copy();
-                entityplayer.inventory.setInventorySlotContents(entityplayer.inventory.currentItem, null);
+                entityplayer.inventory.setItem(entityplayer.inventory.currentItem, null);
                 createTileEntity();
                 world.sendTrackedEntityDataPacket(this);
                 return true;
@@ -478,7 +503,6 @@ public class EntityBoat extends Entity
         }
         return true;
     }
-    
     @Override
     public Entity ejectRider() {
         Entity entity = passenger;
@@ -508,30 +532,7 @@ public class EntityBoat extends Entity
         }
         return entity;
     }
+
     @Override
-    protected void causeFallDamage(float f){}
-
-    private final double maxBoatSpeed = 0.8D;
-    private final double acceleration = 0.0065D;
-    private final float maxRotSpeed = 5f;
-    private final float minRotSpeed = 3f;
-    private final double maxSinglePacketSpeedChange = acceleration * 8;
-    private final double maxSinglePacketRotationChange = maxRotSpeed * 4;
-    public int boatCurrentDamage;
-    public int boatTimeSinceHit;
-    public int boatRockDirection;
-    private int lerpTicks;
-    private double lerpX;
-    private double lerpY;
-    private double lerpZ;
-    private float lerpYRot;
-    private float boatPitch;
-    private double velocityX;
-    private double velocityY;
-    private double velocityZ;
-    private float pendingYRot;
-    private double pendingXDChange;
-    private double pendingZDChange;
-    private ItemStack flag = null;
-    public TileEntityFlag tileEntityFlag = null;
+    protected void causeFallDamage(float distance){}
 }
